#!/bin/bash

# Category : Media & Streaming
# Description : Jellyfin - Media Server (c/u/s/r/i):

installJellyfin()
{
    local config_variables="$1"

    if [[ "$jellyfin" == *[cCtTuUsSrRiI]* ]]; then
        dockerConfigSetupToContainer silent jellyfin;
        local app_name=$CFG_JELLYFIN_APP_NAME
		initializeAppVariables $app_name;
    fi

    if [[ "$jellyfin" == *[cC]* ]]; then
        editAppConfig $app_name;
    fi

	if [[ "$jellyfin" == *[uU]* ]]; then
		dockerUninstallApp $app_name;
	fi

	if [[ "$jellyfin" == *[sS]* ]]; then
		dockerComposeDown $app_name;
	fi

    if [[ "$jellyfin" == *[rR]* ]]; then
        dockerComposeRestart $app_name;
    fi

    if [[ "$jellyfin" == *[iI]* ]]; then
        isHeader "Install $app_name"

		((menu_number++))
        echo ""
        echo "---- $menu_number. Setting up install folder and config file for $app_name."
        echo ""

        dockerConfigSetupToContainer "loud" "$app_name" "install" "$config_variables";
        isSuccessful "Install folders and Config files have been setup for $app_name."

        ((menu_number++))
        echo ""


		((menu_number++))
        echo ""
        echo "---- $menu_number. Pulling a default Jellyfin docker-compose.yml file."
        echo ""

        dockerComposeSetupFile $app_name;

		((menu_number++))
        echo ""
        echo "---- $menu_number. Updating file permissions before starting."
        echo ""

		fixPermissionsBeforeStart $app_name;

		((menu_number++))
        echo ""
        echo "---- $menu_number. Running the docker-compose.yml to install and start Jellyfin"
        echo ""

		dockerComposeUpdateAndStartApp $app_name install;

        ((menu_number++))
        echo ""
        echo "---- $menu_number. Running Application specific updates (if required)"
        echo ""

        appUpdateSpecifics $app_name;

		((menu_number++))
        echo ""
        echo "---- $menu_number. Running Headscale setup (if required)"
        echo ""

		setupHeadscale $app_name;

		((menu_number++))
		echo ""
        echo "---- $menu_number. Adding $app_name to the Apps Database table."
        echo ""

		databaseInstallApp $app_name;

		((menu_number++))
        echo ""
        echo "---- $menu_number. You can find $app_name files at $containers_dir$app_name"
        echo ""
        echo "    You can now navigate to your new service using one of the options below : "
        echo ""

        menuShowFinalMessages $app_name;

		menu_number=0
        #sleep 3s
        cd
	fi
	jellyfin=n
}
